import * as THREE from 'https://threejsfundamentals.org/threejs/resources/threejs/r112/build/three.module.js';
import * as MELON from '../MelonEngine.js';

//People settings
const WALK_CHANGE_TIME = 250;
const MIN_X = -300;
const MIN_Z = -300;
const MAX_X = 300;
const MAX_Z = 300;
const TALK_COOLDOWN = 2500;

//Other settings
const CLOCK_TIME = 1000;
const BASE_CHANCE_OF_OZWOMP = 7;

var people = [];
var lightsDay, lightsDark, lightsPink;

var music1, music2, music3;
var voiceSound, findSound;
var portalSound, feetSound;

var egg, ozwomp;
var clockTimer = CLOCK_TIME - 1;

var sceneIndex = 1;
var talksToNextScene = 4;
var minTimeToNextScene = 0;
var sceneTime = 0;
var timesTalkedThisScene = 0;
var stagesPassed = 0;

//Text
var ozwompsName = "Ozwomp";

const voicePack1 = ['Yes yes I think {oz} will be here soon, just wait',
					'I CAN SPIN AND SPIN LIKE A WIZOGO',
					'No no, I am not {oz} please dont bother me!',
					'Are you waiting for someone? They will be here soon',
					'Soon {oz} will be here, I know it to be true',
					'I am not {oz}, are you?'];

const voicePack2 = ['Ahaha! Its you! ... I have no idea who you are!',
					'Yes yes the weather is very good for a Fungersday',
					'I am not {oz}, please im quite busy here!',
					'Do I look like an {oz} to you!',
					'Keep faith, I know {oz} will arrive soon!',
					'My new book is about the paste, its all the rage'];

const voicePack3 = ['If {oz} praises the paste im sure they will be here soon',
					'Paste be praised, the paste is good the paste is fine!',
					'Please visit the church of the paste next time your in Yonkrip!',
					'Paste Be! {oz} should arrive any moment',
					'On Mongers day I eat paste, you should too',
					'{oz} will be here any moment PASTE BE BLESSED'];

const voicePack4 = ['Its a hard life for a Nombog',
					'I bet {oz} will never come, life is hard',
					'Orbulons are very expensive, Ill get a better price in Yonkrip',
					'Do I look like {oz} to you!? Go away!',
					'Everyone knows {oz} has 2 legs',
					'If you and {oz} need a ride, DONT ASK ME!'];

const voicePack5 = ['I AM NOT {oz}',
					'HELLO, I DO NOT WANT TO BUY ANYTHING',
					'GOOD WEATHER FOR FISHING WHAT HO',
					'ON MY WAY TO VISIT NEMBAX WHAT HO',
					'I HOPE YOU FIND {oz}',
					'IM SURE YOU WILL FIND {oz} SOON'];

MELON.startErUp(init,start,loop);

function init()
{	
	MELON.getActiveScene().background = new THREE.Color( 0x000000 );
	MELON.getActiveScene().fog = new THREE.Fog( 0x000000, 0, 110 );
	
	//Load people
	MELON.loadObject('man1', 0.025, 'Yambaz');
	MELON.loadObject('man1', 0.015, 'Tomberyop');
	MELON.loadObject('man2', 0.025, 'Anagliz');
	MELON.loadObject('man3', 0.021, 'Lemly');
	MELON.loadObject('man4', 0.01, 'Tanswop');
	MELON.loadObject('man4', 0.05, 'Tipton');
	MELON.loadObject('man5', 0.026, 'Yolto');
	MELON.loadObject('man3', 0.05, 'Tanta');
	MELON.loadObject('man2', 0.08, 'Nemtay');
	
	MELON.loadObject('man3', 0.01, 'Ozwomp');
	
	//Load town last to avoid timing issues
	MELON.loadObject('town', 0.02, 'Town');
	
	MELON.loadObject('lights-day', 0.02, 'Lights-Day');
	MELON.loadObject('lights-dark', 0.02, 'Lights-Dark');
	MELON.loadObject('lights-pink', 0.02, 'Lights-Pink');
	
	//Load audio
	music1 = MELON.loadGlobalAudio('1.mp3', true, 0.5);
	music2 = MELON.loadGlobalAudio('2.mp3', true, 0.5);
	music3 = MELON.loadGlobalAudio('3.mp3', true, 0.5);
	
	voiceSound = MELON.loadGlobalAudio('voice.mp3', false, 1);
	findSound = MELON.loadGlobalAudio('find.mp3', false, 0.5);
	
	portalSound = MELON.loadLocalAudio('portal.mp3', 0.5, true, 4);
	feetSound = MELON.loadLocalAudio('feet.mp3', 0.05, true, 5);
}

function start()
{
	//Objects
	egg = MELON.getObjectByName('BigEgg');
	
	MELON.getObjectByName('PortalField').add(portalSound);
	portalSound.play();
	
	//Other
	feetSound.play();
	
	//Ozwomp
	ozwomp = MELON.getObjectByName('Ozwomp');
	ozwomp.position.z = -895;
	ozwomp.position.x = 210;
	ozwomp.rotation.y = 1.57;
	ozwomp.visible = false;
	MELON.registerAction('Ozwomp', function(){ $("#plot-ozwomp").fadeIn("slow"); } );
	
	//Object Text
	MELON.registerAction('PortalField', function(){objectInfoText('Its not your time to enter the portal...');}, true );
	MELON.registerAction('BigEgg', function(){objectInfoText('A big egg is here now.. I WONDER WHY!');}, true );
	MELON.registerAction('Box035', function(){objectInfoText('Antala and the moon rays danced in the dawn of all things');}, true );
	MELON.registerAction('Box036', function(){objectInfoText('It was then OH MAY, taswop, why are you so tall, give me the jar of squids');}, true );
	MELON.registerAction('Box037', function(){objectInfoText('Stormy little beans fell on the rooftops of the city, how lovely');}, true );
	MELON.registerAction('Sphere006', function(){objectInfoText('Perhaps all snowmen are planets to those who know');}, true );
	MELON.registerAction('Cone008', function(){objectInfoText('This cone has nothing to say');}, true );
	MELON.registerAction('Box041', function(){objectInfoText('A box of Toogy Fruit Yum O Mix 9 Billion AND ONE cereal');}, true );
	MELON.registerAction('Box043', function(){objectInfoText('Its an ad for Yanderwops, everyone needs those!');}, true );
	MELON.registerAction('Box039', function(){objectInfoText('Epsy sat on a hill, but did the hill sit on Epsy?');}, true );
	MELON.registerAction('Box040', function(){objectInfoText('Gone is the Dimmonox, its light is here, far away forever');}, true );
	MELON.registerAction('Box045', function(){objectInfoText('Dont poke me! Thats very very rude...');}, true );
	MELON.registerAction('Box044', function(){objectInfoText('Lotowop was at the dember hop, a fine day that was');}, true );
	MELON.registerAction('Box047', function(){objectInfoText('As they danced by the river the sky knew the past was not forgotten');}, true );
	MELON.registerAction('Box046', function(){objectInfoText('Given the state of things, it was only a matter of time');}, true );
	MELON.registerAction('Cone004', function(){objectInfoText('A sign says, Please be kind to Fred the cone');}, true );
	MELON.registerAction('Cone005', function(){objectInfoText('This cone is sad, hopefully someday it wont be');}, true );
	MELON.registerAction('Sphere011', function(){objectInfoText('The ball looks back at you suspiciously');}, true );
	MELON.registerAction('Sphere022', function(){objectInfoText('Its better to forget about things like that');}, true );
	MELON.registerAction('Pyramid001', function(){objectInfoText('Order in the chaos of this entropic space, surrender');}, true );
	MELON.registerAction('Teapot', function(){objectInfoText('Who put that up there!!');}, true );
	MELON.registerAction('Sphere016', function(){objectInfoText('Gobby nebulas! I think I see my house from here');}, true );
	MELON.registerAction('Sphere021', function(){objectInfoText('Anta looks back, so far the knowns are less than the unknowns');}, true );
	MELON.registerAction('Sphere009', function(){objectInfoText('It will be ok, there will be worse days, but not today');}, true );
	MELON.registerAction('Sphere007', function(){objectInfoText('Blue walls are allways broken, paint your walls see through for best results');}, true );
	MELON.registerAction('Sphere020', function(){objectInfoText('The first day was one of the many first days, that did not make it mean less');}, true );
	
	//People
	setUpPerson( 'Ms', 'Yambaz', 0.5, 5 );
	setUpPerson( 'Mr', 'Tomberyop', 0.6, 0.1 );
	setUpPerson( 'Ze', 'Anagliz', 0.4, 5 );
	setUpPerson( 'Mr', 'Lemly', 0.5, 1 );
	setUpPerson( 'Lady', 'Tanswop', 0.7, 0.05 );
	setUpPerson( 'Mr', 'Tipton', 0.5, 2 );
	setUpPerson( 'Lord', 'Yolto', 0.3, 10 );
	setUpPerson( 'Ms', 'Tanta', 0.2, 0.01 );
	setUpPerson( 'Miss', 'Nemtay', 0.1, 0.01 );
	hideAllPeople();
	
	MELON.registerAction('Yambaz', function(){talkFunc( people[0], voicePack1 );} );
	MELON.registerAction('Tomberyop', function(){talkFunc( people[1], voicePack1 );} );
	MELON.registerAction('Anagliz', function(){talkFunc( people[2], voicePack2 );} );
	MELON.registerAction('Lemly', function(){talkFunc( people[3], voicePack3 );} );
	MELON.registerAction('Tanswop', function(){talkFunc( people[4], voicePack4 );} );
	MELON.registerAction('Tipton', function(){talkFunc( people[5], voicePack4 );} );
	MELON.registerAction('Yolto', function(){talkFunc( people[6], voicePack5 );} );
	MELON.registerAction('Tanta', function(){talkFunc( people[7], voicePack3 );} );
	MELON.registerAction('Nemtay', function(){talkFunc( people[8], voicePack2 );} );
	
	//Lighting
	lightsDay = MELON.getObjectByName('Lights-Day');
	lightsDark = MELON.getObjectByName('Lights-Dark');
	lightsPink = MELON.getObjectByName('Lights-Pink');
	hideAllLights();
	
	//Set stage
	setStage1();
	MELON.printToConsole('You are waiting for ' + ozwompsName + '...');
}

function loop()
{
	sceneTime++;
	//MELON.printToConsole(sceneTime);
	
	//Clock fade logic
	if(clockTimer > -1) { clockTimer++; }
	if(clockTimer == CLOCK_TIME)
	{
		clockTimer = -1;
		doClockFadeOut();
	}
	
	//People logic
	for(var p=0 ; p<people.length ; p++)
	{
		var person = people[p];
		
		//Direction chnages
		person.movment.changeTime++;
		if(person.movment.changeTime > WALK_CHANGE_TIME)
		{
			person.movment.changeTime = 0;
			person.movment.direction = MELON.getRandomInt(0,6); //buffed so they stand still sometimes
		}
		
		//Rotation
		if(person.rotation.y < person.movment.targetRot) { person.rotation.y += person.movment.turnSpeed }
		else if(person.rotation.y > person.movment.targetRot) { person.rotation.y -= person.movment.turnSpeed }
		
		//Movment
		switch( person.movment.direction )
		{
			case 0:
				person.position.x += person.movment.walkSpeed; 
				if(person.position.x > MAX_X) { person.movment.changeTime = WALK_CHANGE_TIME; } //Force a change if outside bounds
				person.movment.targetRot = 160;
				break;
			case 1:
				person.position.x -= person.movment.walkSpeed;
				if(person.position.x < MIN_X) { person.movment.changeTime = WALK_CHANGE_TIME; }
				person.movment.targetRot = 0;
				break;
			case 2:
				person.position.z += person.movment.walkSpeed;
				if(person.position.z > MAX_Z) { person.movment.changeTime = WALK_CHANGE_TIME; }
				person.movment.targetRot = 90;
				break;
			case 3:
				person.position.z -= person.movment.walkSpeed;
				if(person.position.z < MIN_Z) { person.movment.changeTime = WALK_CHANGE_TIME; }
				person.movment.targetRot = -90;
				break;
		}
	}
}

function setStage1()
{
	sceneIndex = 1;
	timesTalkedThisScene = 0;
	talksToNextScene = 2;
	sceneTime = 0;
	minTimeToNextScene = 5000;
	
	MELON.getActiveScene().background = new THREE.Color( 0x000000 );
	MELON.getActiveScene().fog = new THREE.Fog( 0x000000, 0, 110 );
	
	egg.visible = false;
	hideAllPeople();
	people[0].visible = true;
	people[3].visible = true;
	people[2].visible = true;
	hideAllLights();
	lightsDark.visible = true;
	
	music3.play();
}

function setStage2()
{
	sceneIndex = 2;
	timesTalkedThisScene = 0;
	talksToNextScene = 4;
	sceneTime = 0;
	minTimeToNextScene = 7000;
	
	MELON.getActiveScene().background = new THREE.Color( 0xff6af8 );
	MELON.getActiveScene().fog = new THREE.Fog( 0xff6af8, 0, 90 );
	
	egg.visible = true;
	hideAllPeople();
	people[1].visible = true;
	people[4].visible = true;
	people[5].visible = true;
	people[6].visible = true;
	hideAllLights();
	lightsPink.visible = true;
	
	music2.play();
}

function setStage3()
{
	sceneIndex = 3;
	timesTalkedThisScene = 0;
	talksToNextScene = 3;
	sceneTime = 0;
	minTimeToNextScene = 4000;
	
	MELON.getActiveScene().background = new THREE.Color( 0x1e0d52 );
	MELON.getActiveScene().fog = new THREE.Fog( 0x1e0d52, 0, 70 );
	
	egg.visible = false;
	hideAllPeople();
	people[6].visible = true;
	people[7].visible = true;
	people[8].visible = true;
	people[0].visible = true;
	people[1].visible = true;
	hideAllLights();
	lightsDay.visible = true;
	
	music1.play();
}

function hideAllLights()
{
	lightsDay.visible = false;
	lightsDark.visible = false;
	lightsPink.visible = false;
}

function hideAllPeople()
{
	for(var i=0 ; i<people.length ; i++)
	{
		people[i].visible = false;
		people[i].talkTime = 0;
	}
}

function doClockFadeIn() //ALSO DOES STAGE RESET
{
	if(music1.isPlaying) {music1.stop();}
	if(music2.isPlaying) {music2.stop();}
	if(music3.isPlaying) {music3.stop();}
	
	$( "#plot-clock" ).first().fadeIn( "slow", function() 
	{
		//Function called when fade is done
		stagesPassed++;
		MELON.printToConsole('<br>... MANY HOURS PASS - EPOCH '+stagesPassed+' ...<br>');
    	clockTimer = 0;
		switch(sceneIndex)
		{
			case 1: setStage2(); break;
			case 2: setStage3(); break;
			case 3: setStage1(); break;
		}
		//Is ozwomp here?
		ozwomp.visible = false;
		if(MELON.getRandomInt(0, 100) <= (BASE_CHANCE_OF_OZWOMP * stagesPassed))
		{
			ozwomp.visible = true;
		}
  	});
}

function doClockFadeOut()
{
	$( "#plot-clock" ).first().fadeOut( "slow" );
}

function setUpPerson( title, name, walkSpeed, turnSpeed )
{
	var portal = MELON.getObjectByName('PortalField');
	
	var p1 = MELON.getObjectByName(name);
	p1.talkTime = 0;
	p1.nameTitle = title;
	p1.position.x = portal.position.x;
	p1.position.z = portal.position.z + 400;
	p1.movment = {};
	p1.movment.direction = 2;
	p1.movment.turnSpeed = turnSpeed;
	p1.movment.walkSpeed = walkSpeed;
	p1.movment.changeTime = MELON.getRandomInt(0, WALK_CHANGE_TIME); //set random move time
	p1.add(feetSound);
	people.push(p1);
}

function objectInfoText( text )
{
	MELON.printToConsole( text );
	if(findSound.isPlaying) { findSound.stop(); }
	findSound.play();
	
	//Scene progress
	timesTalkedThisScene++;
	if( timesTalkedThisScene >= talksToNextScene && sceneTime >= minTimeToNextScene ) { doClockFadeIn() }
}

function talkFunc( person, sayingsArray )
{
	//Cooldown system
	if( person.talkTime != 0 && (sceneTime - person.talkTime) < TALK_COOLDOWN ) { return; }
	person.talkTime = sceneTime;
	
	//Text processing
	var pick = MELON.getRandomInt(0, sayingsArray.length);
	var saying = sayingsArray[pick].replace('{oz}', ozwompsName);
	MELON.printToConsole( person.nameTitle + ' ' + person.name + ': ' + saying );
	
	if(voiceSound.isPlaying) { voiceSound.stop(); }
	voiceSound.play();
	
	//Scene progress
	timesTalkedThisScene++;
	if( timesTalkedThisScene >= talksToNextScene && sceneTime >= minTimeToNextScene ) { doClockFadeIn() }
}






